#version 330 core

in vec3 texCoord;
in vec3 cloudTexCoord;
in vec3 vertexPos;
layout(location = 0)out vec4 fragColor;

uniform samplerCube cubemap;
uniform sampler2D clouds;
uniform float time;

void main()
{
	vec4 texColor = texture(cubemap, texCoord);
	vec3 tc = cloudTexCoord;
	float a = ((0.2*abs(tc.x-0.5)));
	float v = cloudTexCoord.z*min(1,1.2+a-(abs(cloudTexCoord.y-0.5)*2));
	v = v*v*v;
	
	float clouds1 = texture(clouds, vec2(tc.x+time*0.005,tc.y)).r;
	float clouds2 = texture(clouds, vec2(cloudTexCoord.x-time*0.001,cloudTexCoord.y*0.5)).r;
	clouds1 *= clouds1;
	clouds2 *= clouds2;
	float r = texture(clouds, vec2(0.1+cloudTexCoord.x+time*0.0005,cloudTexCoord.y*0.8)).r;
	float g = texture(clouds, vec2(0.3+cloudTexCoord.x-time*0.0008,cloudTexCoord.y*0.4)).r;
	float b = texture(clouds, vec2(cloudTexCoord.x+time*0.0003,cloudTexCoord.y*0.3)).r;

    fragColor = texColor + clouds1*clouds2*v*vec4(r,g,b,1);
}