#version 330 core
layout(location = 0)in vec3 vertexPosition;
layout(location = 1)in vec3 vertexNormal;
layout(location = 2)in vec3 vertexTexCoord;
layout(location = 3)in vec4 vertexTangent;

layout(std140) uniform CameraInfo
{
	mat4 projectionMat;
	mat4 viewMat;
};
layout(std140) uniform LightingInfo
{
	vec3 lightPosition;
	vec3 ambientColor;
	vec3 lightColor;
};

uniform mat4 modelMat;
uniform mat3 normalMat;

out vec3 texCoord;
out vec3 cloudTexCoord;
out vec3 vertexPos;

void main() {
	mat4 vm = viewMat;
	vm[3][0] = 0; vm[3][1] = 0;vm[3][2]=0;		
	texCoord = normalize(vertexPosition.zyx);
	texCoord.y*=-1;
	cloudTexCoord = vertexTexCoord;
	vertexPos = vertexPosition;
	gl_Position = projectionMat * vm * modelMat* vec4(vertexPosition,1);
}