#version 330 core
#define MAX_NUM_POSITIONS 256

layout(location = 0)in vec2 vertexTexCoord;

layout(std140) uniform CameraInfo
{
	mat4 projectionMat;
	mat4 viewMat;
};
layout(std140) uniform SwarmPositions
{
	vec4 positions[MAX_NUM_POSITIONS];
};

uniform mat4 modelMat;

uniform vec2 billboardSize;

out vec2 texCoord;

void main() {
	vec3 cR_world = vec3(viewMat[0][0], viewMat[1][0], viewMat[2][0]);
	vec3 cU_world = vec3(viewMat[0][1], viewMat[1][1], viewMat[2][1]);
	vec4 wp = positions[gl_InstanceID];
	vec3 v_ws = wp.xyz 
	+ cR_world * (vertexTexCoord.x) * billboardSize.x 
	+ cU_world * (vertexTexCoord.y) * billboardSize.y;
	
	gl_Position = projectionMat * viewMat * vec4(v_ws,1);
	texCoord = vertexTexCoord+0.5;
}